/*
  AD9850.h - Library for interfacing AD9850 function generator.
  Created by Raivis Strogonovs, November 25, 2013.
  Released into the public domain.
*/
#ifndef AD9850_h
#define AD9850_h
 
#include "Arduino.h"
 
 //Frequency of your crystal oscillator (CLKIN input pin 9 in datasheet), measured in MHz.
	// This reference frequency must be higher than 1MHz.
	#define XTAL_MHZ 125

	//Relationship value between actual frequency and 32-bit word sent in the serial streaming
	#define FREQ_FACTOR 4294.967295
 
class AD9850
{
  public:
    AD9850(int W_CLK, int FQ_UD, int DATA, int RESET);
	void init();
        void doReset();
	void testFreq();
        void osc(double frequency, double phase);
    
 
  private:
    int _W_CLK;
    int _FQ_UD;
    int _DATA;
	int _RESET;
    
};
 
#endif
