#include "AD9850.h"

#define SET(x,y) (x |=(1<<y))				//-Bit set/clear macros
#define CLR(x,y) (x &= (~(1<<y)))       		// |
#define CHK(x,y) (x & (1<<y))           		// |
#define TOG(x,y) (x^=(1<<y))            		//-+



#define N 160  //How many frequencies

#define MIN_FREQ 25000
#define MAX_FREQ 310000
#define SWEEP_STEP (MAX_FREQ-MIN_FREQ)/N

float results[N];            //-Filtered result buffer
float freq[N];            //-Filtered result buffer
int sizeOfArray = N;

 
 #include <SoftwareSerial.h>

SoftwareSerial bluetoothSerial(3, 2); // RX, TX
   

String command = "";   
AD9850 device(4,12,7,8);
//AD9850 device(4,12,7,8);
unsigned long singleStep;
unsigned long maxFreq;
unsigned long initialFreq;

void setup()
{
  
  
  
  TCCR1A=0b10000010;        //-Set up frequency generator
  TCCR1B=0b00011001;        //-+
  ICR1=125;
  OCR1A=62;

  pinMode(9,OUTPUT);        //-Signal generator pin
  pinMode(8,OUTPUT);        //-Sync (test) pin*/

  Serial.begin(115200); //115200

Serial.println("Ready");

	device.init();
	device.doReset();
        device.osc(2000,0);

        
        


  // set the data rate for the SoftwareSerial port
  bluetoothSerial.begin(115200);

  
  maxFreq = (long)MAX_FREQ*FREQ_FACTOR/XTAL_MHZ;
  initialFreq = (long)MIN_FREQ*FREQ_FACTOR/XTAL_MHZ;
  singleStep = (maxFreq-initialFreq) / N;
  
  Serial.print("Single step: ");
  Serial.print(singleStep);
  Serial.print(" ");
  Serial.println(SWEEP_STEP);
  bluetoothSerial.println("Ready");
  
//  digitalWrite(4, HIGH);
//  digitalWrite(12, HIGH);
//  digitalWrite(7, HIGH);
//  digitalWrite(8, HIGH);
  /*for(int i=0;i<N;i++)      //-Preset results
    results[i]=0;         //-+*/
}
unsigned long frequency = 1000;

char inData[20]; // Allocate some space for the string
char inChar; // Where to store the character read
byte index = 0; // Index into array; where to store the character
boolean sweep = false;

char configData[24];



void loop()
{
  
//  device.oscInt(frequency);
//  frequency+=1000;
//  if(frequency > 10000000)
//    //device.osc(frequency, 0);
// 
//     frequency = 0;

   
     
     if(Serial.available())
     {
       inChar = Serial.read(); // Read a character
     
       if(inChar == 'n')
         frequency += SWEEP_STEP;
       else if(inChar == 'b')
         frequency -= SWEEP_STEP;
       else if(inChar == 'r')
          frequency = 1000;
       else if(inChar == 'o')
          frequency = random(30);
       else if(inChar == 's')
       {
           sweep = !sweep;
           frequency = 1000;
       }
       
      device.osc(frequency, 0);
     }
     
     if(bluetoothSerial.available())
     {
       char currentChar = 0;       
       while(bluetoothSerial.available() > 0)
       {
         if(currentChar < 23)
         {
           configData[currentChar] = bluetoothSerial.read();
           currentChar++;
           configData[currentChar] = '\0';
         }
       }
       //Config read
       Serial.print("New Config: ");
       Serial.println(configData);
     }
    //delay(1);
    
    if(sweep == true)
    {
       doSweep();
    }
//    TOG(PORTB,1);  
//     int v=analogRead(0); 
//     Serial.println(v);

//    delay(1);
//    digitalWrite(9, HIGH);
//        delay(1);
//    digitalWrite(9, LOW);

//    
//    unsigned int d;
//
//  int counter = 0;
//  for(unsigned int d=0;d<N;d++)
//  {
//    int v=analogRead(0);    //-Read response signal
//    frequency += singleStep;
//    device.oscInt(frequency);
//    delay(1000);
//
//    results[d]=results[d]*0.5+(float)(v)*0.5; //Filter results
//   
//    freq[d] = d;
//  }
//
//    bluetoothSerial.print("{");
//    for (unsigned int d=0; d<N; d++) {    
//      bluetoothSerial.print(results[d]);
//      bluetoothSerial.print(" ");
//    }
//  bluetoothSerial.print("}");
//  bluetoothSerial.println();
}

void doSweep()
{
  unsigned int d;

  int counter = 0;
  frequency = initialFreq;
   device.oscInt(frequency);
        
          
  for(unsigned int d=0;d<N;d++)
  {
    digitalWrite(9, HIGH);
    int v=analogRead(0);    //-Read response signal
    frequency = frequency + singleStep;
    device.oscInt(frequency);
    
    results[d]=results[d]*0.5+(float)(v)*0.5; //Filter results
//    results[d] = (float)(v);
   
    freq[d] = d;
    
    digitalWrite(9, LOW);    
  }
  
  //Print results thoruhg bluetooth
  bluetoothSerial.print("{");
  for (unsigned int d=0; d<N; d++) 
  {    
    bluetoothSerial.print(results[d]);
    bluetoothSerial.print(" ");
  }
  bluetoothSerial.print("}");
  bluetoothSerial.println();
}

void loop2()
{
  unsigned int d;

  int counter = 0;
  for(unsigned int d=0;d<N;d++)
  {
    int v=analogRead(0);    //-Read response signal
    CLR(TCCR1B,0);          //-Stop generator
    TCNT1=0;                //-Reload new frequency
    ICR1=d;                 // |
    OCR1A=d/2;              //-+
    SET(TCCR1B,0);          //-Restart generator

    results[d]=results[d]*0.5+(float)(v)*0.5; //Filter results
   
    freq[d] = d;
    


 //   plot(v,0);              //-Display
 //   plot(results[d],1);
  // delayMicroseconds(1);
  delay(1000);
  }
  
     //  int v=analogRead(0);    //-Read response signal
//    CLR(TCCR1B,0);          //-Stop generator
//    TCNT1=0;                //-Reload new frequency
//    ICR1=3;                 // |
//    OCR1A=3/2;              //-+
//    SET(TCCR1B,0);          //-Restart generator

bluetoothSerial.print("{");
  for (unsigned int d=0; d<N; d++) {    
    bluetoothSerial.print(results[d]);
    bluetoothSerial.print(" ");
  }
  bluetoothSerial.print("}");
  bluetoothSerial.println();
//PlottArray(1,freq,results); 
 

  //TOG(PORTB,0);            //-Toggle pin 8 after each sweep (good for scope)
}
