
#define MAXDIV 32

const int analogPin = A0;
const int pwmPin = 9;

int rets[MAXDIV];
int division;

//Initializes oc1a to output a frequency of (20MHz/div)
void pwmInit(int div) {
	TCCR1A=0x82;	//Fast pwm, top=ICR1
	TCCR1B=0x19;	//no prescaler
	OCR1A=div-1;
	ICR1=(div*2);
}

void setup()
{
  Serial.begin(9600);
  pinMode(pwmPin, OUTPUT);
  
  pwmInit(0);
}

void loop()
{
  //Do a frequency sweep.
  for (division=0; division<MAXDIV; division++) {
    pwmInit(division+1);
    //Wait for the RC-filter to settle
    delay(10);
    //Sample the Analog value
    rets[division]=analogRead(analogPin);
  }
  pwmInit(1);
  Serial.print("{");
  for (division=0; division<MAXDIV; division++) {    
    Serial.print(rets[division]);
    Serial.print(" ");
  }
  Serial.print("}");
  Serial.println();

}

