#ifndef AD9850_H
#define AD9850_H


 //Frequency of your crystal oscillator (CLKIN input pin 9 in datasheet), measured in MHz.
 // This reference frequency must be higher than 1MHz.
 #define XTAL_MHZ 125

 //Relationship value between actual frequency and 32-bit word sent in the serial streaming
 #define FREQ_FACTOR 4294.967295
 
 #define HIGH 10
 #define LOW 0
 
 #define _PORT_N PORTC_OUT

class AD9850
{
	public:
		AD9850(uint8_t W_CLK, uint8_t FQ_UD, uint8_t DATA, uint8_t RESET);
		void init();
		void doReset();
		void osc(double frequency, double phase);
		void oscInt(unsigned long y);
		
		
	private:
		uint8_t _W_CLK;
		uint8_t _FQ_UD;
		uint8_t _DATA;
		uint8_t _RESET;
		
		void digitalWrite(uint8_t pin, uint8_t state);
		
		
};

#endif //AD9850_H