#include "keydelegate.h"

KeyDelegate::KeyDelegate(QObject *parent) :
    QStyledItemDelegate(parent)
{
}


QWidget *KeyDelegate::createEditor(QWidget *parent,
    const QStyleOptionViewItem &/* option */,
    const QModelIndex &/* index */) const
{
    KeyBinder *editor = new KeyBinder(parent);

    return editor;
}

void KeyDelegate::setEditorData(QWidget *editor,
                                    const QModelIndex &index) const
{
    //If tree widget double clicked, it will initiate this method
    QString value = index.model()->data(index, Qt::EditRole).toString();

    KeyBinder *spinBox = static_cast<KeyBinder*>(editor);
    spinBox->setText(value);
}

void KeyDelegate::setModelData(QWidget *editor, QAbstractItemModel *model,
                                   const QModelIndex &index) const
{
    //First lets set known data from tree widget
    KeyBinder *spinBox = static_cast<KeyBinder*>(editor);
    //QLineEdit->interpretText();
    QString value = spinBox->text();

    model->setData(index, value, Qt::EditRole);
    spinBox->releaseKeyboard();
}

void KeyDelegate::updateEditorGeometry(QWidget *editor,
    const QStyleOptionViewItem &option, const QModelIndex &/* index */) const
{
    //Perform widget scaling to fill the tree widget's field
    editor->setGeometry(option.rect);
}
