#include "simulatekeyboard.h"
#include "ui_simulatekeyboard.h"

SimulateKeyboard::SimulateKeyboard(QWidget *parent) :
    QDialog(parent),
    ui(new Ui::SimulateKeyboard)
{
    ui->setupUi(this);
    ui->keyMap->setItemDelegate(new KeyDelegate(this));
    ui->keyMap->setFocusPolicy(Qt::NoFocus);

    connect(ui->simulateBtn, SIGNAL(clicked(bool)), this, SLOT(sendKeys(bool)));
}

void SimulateKeyboard::gesture(int g)
{
//    if(ui->keyMap->topLevelItem(g)->text(1).isEmpty())
//        return;

    INPUT ip;
   // Set up a generic keyboard event.
   ip.type = INPUT_KEYBOARD;
   ip.ki.wScan = 0; // hardware scan code for key
   ip.ki.time = 0;
   ip.ki.dwExtraInfo = 0;

   // Press the "A" key
   ip.ki.wVk = ui->keyMap->topLevelItem(g)->text(1).toInt(); // virtual-key code for the "a" key
   ip.ki.dwFlags = 0; // 0 for key press
   SendInput(1, &ip, sizeof(INPUT));

   // Release the "A" key
   ip.ki.dwFlags = KEYEVENTF_KEYUP; // KEYEVENTF_KEYUP for key release
   SendInput(1, &ip, sizeof(INPUT));
}

void SimulateKeyboard::sendKeys(bool enabled)
{
    if(enabled)
    {
        qDebug() << "Starting keyboard simulation";
       INPUT ip;

       Sleep(1000);
      // Set up a generic keyboard event.
      ip.type = INPUT_KEYBOARD;
      ip.ki.wScan = 0; // hardware scan code for key
      ip.ki.time = 0;
      ip.ki.dwExtraInfo = 0;

      // Press the "A" key
      ip.ki.wVk = ui->keyMap->topLevelItem(0)->text(1).toInt(); // virtual-key code for the "a" key
      ip.ki.dwFlags = 0; // 0 for key press
      SendInput(1, &ip, sizeof(INPUT));
        Sleep(200);
      // Release the "A" key
      ip.ki.dwFlags = KEYEVENTF_KEYUP; // KEYEVENTF_KEYUP for key release
      SendInput(1, &ip, sizeof(INPUT));

      qDebug() << "key press simulated";
    }
}

void SimulateKeyboard::setGestures(QStringList gestures)
{
    this->availableGestures = gestures;

   // ui->keyMap->clear();

    foreach(QString gesture, availableGestures)
    {
        QTreeWidgetItem *newItem = new QTreeWidgetItem(ui->keyMap);
        newItem->setText(0,gesture);
        newItem->setTextAlignment(1, Qt::AlignHCenter);
        newItem->setFlags(newItem->flags() | Qt::ItemIsEditable);

    }
}

SimulateKeyboard::~SimulateKeyboard()
{
    delete ui;
}

