#include "serialterminal.h"
#include "ui_serialterminal.h"

SerialTerminal::SerialTerminal(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::SerialTerminal)
{
    ui->setupUi(this);

    QToolBar *toolBar = new QToolBar("Terminal Tools", this);

    QAction *clearAction = new QAction(QIcon(":/images/edit-clear.png"), "Clear",toolBar);
    toolBar->addAction(clearAction);
    connect(clearAction, SIGNAL(triggered()), ui->terminal, SLOT(clear()));
    connect(ui->sendBtn, SIGNAL(clicked()), this, SLOT(commandSend()));


    this->addToolBar(toolBar);
}

void SerialTerminal::keyReleaseEvent(QKeyEvent *e)
{
    if(e->key() == Qt::Key_Return)
        emit sendToSerial( QByteArray( QString("\n").toLatin1() ) );
    else
        emit sendToSerial( QByteArray( QString(e->text()).toLatin1() ) );
    //QMainWindow::keyReleaseEvent(e);
}

void SerialTerminal::commandSend()
{
    emit sendToSerial( QByteArray( QString(ui->cmdEdit->text().append("\n")).toLatin1() ) );
}

void SerialTerminal::writeToTerminal(QString text)
{

    text.replace("\n\r", "\n");
    text.replace("\r\n", "\n");


    ui->terminal->insertPlainText( text );
    QTextCursor c =  ui->terminal->textCursor();
    c.movePosition(QTextCursor::End);
    ui->terminal->setTextCursor(c);
}

SerialTerminal::~SerialTerminal()
{
    delete ui;
}
